<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>HexPlot: /home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/utils/root_utils.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.1 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>/home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/utils/root_utils.h File Reference</h1>
<p>A collection of ROOT helper functions.  
<a href="#_details">More...</a></p>
<code>#include &lt;fstream&gt;</code><br/>
<code>#include &lt;iomanip&gt;</code><br/>
<code>#include &lt;limits&gt;</code><br/>
<code>#include &lt;sstream&gt;</code><br/>
<code>#include &lt;utility&gt;</code><br/>
<code>#include &quot;TCanvas.h&quot;</code><br/>
<code>#include &quot;TF1.h&quot;</code><br/>
<code>#include &quot;TFile.h&quot;</code><br/>
<code>#include &quot;TGraph.h&quot;</code><br/>
<code>#include &quot;TGraphAsymmErrors.h&quot;</code><br/>
<code>#include &quot;TGraphErrors.h&quot;</code><br/>
<code>#include &quot;TH1F.h&quot;</code><br/>
<code>#include &quot;TH2D.h&quot;</code><br/>
<code>#include &quot;TH2F.h&quot;</code><br/>
<code>#include &quot;TMath.h&quot;</code><br/>
<code>#include &quot;TMatrixD.h&quot;</code><br/>
<code>#include &quot;TPad.h&quot;</code><br/>
<code>#include &quot;TPaletteAxis.h&quot;</code><br/>
<code>#include &quot;TPaveText.h&quot;</code><br/>
<code>#include &quot;TPolyLine.h&quot;</code><br/>
<code>#include &quot;TRandom.h&quot;</code><br/>
<code>#include &quot;TSpline.h&quot;</code><br/>
<code>#include &quot;TText.h&quot;</code><br/>
<code>#include &quot;TTreePlayer.h&quot;</code><br/>
<code>#include &quot;TVector2.h&quot;</code><br/>
<code>#include &quot;TVirtualPad.h&quot;</code><br/>
<code>#include &quot;<a class="el" href="cpp__utils_8h_source.html">cpp_utils.h</a>&quot;</code><br/>

<p><a href="root__utils_8h_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad5f5a1d82550a0169d09502868b7579a"></a><!-- doxytag: member="root_utils.h::get_barlow_corr_factor" ref="ad5f5a1d82550a0169d09502868b7579a" args="(double m, double n, double N, int verbose=1, int replacement=1)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ad5f5a1d82550a0169d09502868b7579a">get_barlow_corr_factor</a> (double m, double n, double N, int verbose=1, int replacement=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns Barlow correction factor for pseudo-experiments. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af6332a6e51e0542bcba185b29643f18c"></a><!-- doxytag: member="root_utils.h::round_to_n_digits" ref="af6332a6e51e0542bcba185b29643f18c" args="(double value, int nDigits)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#af6332a6e51e0542bcba185b29643f18c">round_to_n_digits</a> (double value, int nDigits)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Rounds a double to n counting digits. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a08cd335d527f6713eed4693cd499afc3"></a><!-- doxytag: member="root_utils.h::round_to_error_n_digits" ref="a08cd335d527f6713eed4693cd499afc3" args="(double value, double unc, int nDigits, std::string &amp;outputValue, std::string &amp;outputUnc)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a08cd335d527f6713eed4693cd499afc3">round_to_error_n_digits</a> (double value, double unc, int nDigits, std::string &amp;outputValue, std::string &amp;outputUnc)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Rounds a double with uncertainty to n counting digits. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a19091230244d038529b55cb80f5a0fcd"></a><!-- doxytag: member="root_utils.h::rounding_example" ref="a19091230244d038529b55cb80f5a0fcd" args="()" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a19091230244d038529b55cb80f5a0fcd">rounding_example</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Displays how the above rounding function works. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2a613634f03b447b002a0bd9780ce3e6"></a><!-- doxytag: member="root_utils.h::unc_of_diff" ref="a2a613634f03b447b002a0bd9780ce3e6" args="(double unc0, double unc1, double rho=0, double factor=1)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a2a613634f03b447b002a0bd9780ce3e6">unc_of_diff</a> (double unc0, double unc1, double rho=0, double factor=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Determines the uncertainty of a difference of two values with uncertainties with optional scale factor. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#afb180631ffde31f2d493d4bad238fb5d">unc_of_ratio</a> (double n, double N, double ne, double Ne, double corr, bool verbose=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the uncertainty of a ratio.  <a href="#afb180631ffde31f2d493d4bad238fb5d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac05284c42b83e7861f8e785ce29b7abb"></a><!-- doxytag: member="root_utils.h::unc_of_ratio" ref="ac05284c42b83e7861f8e785ce29b7abb" args="(int n, int N, double corr, bool verbose)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ac05284c42b83e7861f8e785ce29b7abb">unc_of_ratio</a> (int n, int N, double corr, bool verbose)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the uncertainty of a ratio by calling <a class="el" href="root__utils_8h.html#afb180631ffde31f2d493d4bad238fb5d" title="Returns the uncertainty of a ratio.">unc_of_ratio()</a>. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abb77fedf69dd913ca5b1b8131888a725"></a><!-- doxytag: member="root_utils.h::unc_of_ratio" ref="abb77fedf69dd913ca5b1b8131888a725" args="(int n, int N, bool verbose)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#abb77fedf69dd913ca5b1b8131888a725">unc_of_ratio</a> (int n, int N, bool verbose)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the uncertainty of a ratio <a class="el" href="root__utils_8h.html#afb180631ffde31f2d493d4bad238fb5d" title="Returns the uncertainty of a ratio.">unc_of_ratio()</a>. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7eb03b851974cda162d65520d7309e70"></a><!-- doxytag: member="root_utils.h::get_phi_from_xy" ref="a7eb03b851974cda162d65520d7309e70" args="(double x, double y)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a7eb03b851974cda162d65520d7309e70">get_phi_from_xy</a> (double x, double y)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates phi from x and y coordinates. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aad008cc5df6e137092576ea8481b9107"></a><!-- doxytag: member="root_utils.h::get_corr_factor_unc" ref="aad008cc5df6e137092576ea8481b9107" args="(TH2F *h)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aad008cc5df6e137092576ea8481b9107">get_corr_factor_unc</a> (TH2F *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the uncertainty of a correlation factor. Warning: get_corr_factor_unc not fully implemented yet! <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a36974b18c7650c95c7812bfec5a6f6d0">get_min_hist_region</a> (TH1F *h, double frac=1.0, const std::string &amp;quant=&quot;RMS&quot;, bool verbose=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns quantity in smallest region containing frac of all events.  <a href="#a36974b18c7650c95c7812bfec5a6f6d0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae509fbd8110f68205a1c467b6a738d8b"></a><!-- doxytag: member="root_utils.h::incr_mean_calc" ref="ae509fbd8110f68205a1c467b6a738d8b" args="(double oldMean, int newN, double newVal)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ae509fbd8110f68205a1c467b6a738d8b">incr_mean_calc</a> (double oldMean, int newN, double newVal)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Incrementally calculates the mean. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="add9a734c52f887fd434c0174fd806039"></a><!-- doxytag: member="root_utils.h::incr_STD_dev_calc" ref="add9a734c52f887fd434c0174fd806039" args="(double oldSigma, double oldMean, int newN, double newVal)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#add9a734c52f887fd434c0174fd806039">incr_STD_dev_calc</a> (double oldSigma, double oldMean, int newN, double newVal)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Incrementally calculates the standard deviation. Warning: not implemented yet! <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a017accbb4acd874db60c0764207782e0"></a><!-- doxytag: member="root_utils.h::RMS_test" ref="a017accbb4acd874db60c0764207782e0" args="(int nmax)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a017accbb4acd874db60c0764207782e0">RMS_test</a> (int nmax)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tests the functions <a class="el" href="root__utils_8h.html#ae509fbd8110f68205a1c467b6a738d8b" title="Incrementally calculates the mean.">incr_mean_calc()</a> and <a class="el" href="root__utils_8h.html#add9a734c52f887fd434c0174fd806039" title="Incrementally calculates the standard deviation. Warning: not implemented yet!">incr_STD_dev_calc()</a>. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7393edc7d217aab6d3760ec80156f193"></a><!-- doxytag: member="root_utils.h::get_delta_R" ref="a7393edc7d217aab6d3760ec80156f193" args="(double eta0, double phi0, double eta1, double phi1)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a7393edc7d217aab6d3760ec80156f193">get_delta_R</a> (double eta0, double phi0, double eta1, double phi1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates delta R from angles. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a18b866f9a6a3c988e07f765caa6f8c75"></a><!-- doxytag: member="root_utils.h::get_eta_from_theta" ref="a18b866f9a6a3c988e07f765caa6f8c75" args="(double theta)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a18b866f9a6a3c988e07f765caa6f8c75">get_eta_from_theta</a> (double theta)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Converts theta to eta. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2ff6f4e14668359ea38483ba096a6ce5"></a><!-- doxytag: member="root_utils.h::get_theta_from_eta" ref="a2ff6f4e14668359ea38483ba096a6ce5" args="(double eta)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a2ff6f4e14668359ea38483ba096a6ce5">get_theta_from_eta</a> (double eta)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Converts eta to theta. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0ea87ad7d0879248f2e649abb42a1797"></a><!-- doxytag: member="root_utils.h::get_color_line_fill_style" ref="a0ea87ad7d0879248f2e649abb42a1797" args="(int number)" -->
int *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a0ea87ad7d0879248f2e649abb42a1797">get_color_line_fill_style</a> (int number)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns different settings for color, line and fill style for iterative assignment. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4618476f3c4d188d1fa2c5480f5e12ea"></a><!-- doxytag: member="root_utils.h::get_color_line_fill_style_no_black" ref="a4618476f3c4d188d1fa2c5480f5e12ea" args="(int number)" -->
int *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a4618476f3c4d188d1fa2c5480f5e12ea">get_color_line_fill_style_no_black</a> (int number)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns different settings for color, line and fill style for iterative assignment without black. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5f1b31d44d1567b3fd505f1b85c5078d"></a><!-- doxytag: member="root_utils.h::cut_off_bins" ref="a5f1b31d44d1567b3fd505f1b85c5078d" args="(TH1F *h, int nLastBins)" -->
TH1F *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a5f1b31d44d1567b3fd505f1b85c5078d">cut_off_bins</a> (TH1F *h, int nLastBins)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Cuts off the last bins of a histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae646dc89429b10d6b87bc0af026e88ee"></a><!-- doxytag: member="root_utils.h::save_pad" ref="ae646dc89429b10d6b87bc0af026e88ee" args="(TPad *pad, const char *saveName, int x=700, int y=500)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ae646dc89429b10d6b87bc0af026e88ee">save_pad</a> (TPad *pad, const char *saveName, int x=700, int y=500)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Saves a single pad from a canvas. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a03035db434c0958029381a0b3db50bcf"></a><!-- doxytag: member="root_utils.h::save_pad" ref="a03035db434c0958029381a0b3db50bcf" args="(TVirtualPad *pad, const char *saveName, int x=700, int y=500)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a03035db434c0958029381a0b3db50bcf">save_pad</a> (TVirtualPad *pad, const char *saveName, int x=700, int y=500)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Saves a single pad from a canvas. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a63c2f89433a14a956973febf40e39572"></a><!-- doxytag: member="root_utils.h::remove_negative_bins" ref="a63c2f89433a14a956973febf40e39572" args="(TH1 *hist)" -->
int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a63c2f89433a14a956973febf40e39572">remove_negative_bins</a> (TH1 *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets negative bins to 0 and returns number of changed bins. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a79ed0ebd78ee6f532538f82ed7de8fd0"></a><!-- doxytag: member="root_utils.h::remove_NAN_bins" ref="a79ed0ebd78ee6f532538f82ed7de8fd0" args="(TH1 *hist)" -->
int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a79ed0ebd78ee6f532538f82ed7de8fd0">remove_NAN_bins</a> (TH1 *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets NAN bins to 0 and returns number of changed bins. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa5152256eac42249db46ce9da25bef6a"></a><!-- doxytag: member="root_utils.h::remove_OF_bins" ref="aa5152256eac42249db46ce9da25bef6a" args="(TH1 *hist, double OFvalue=MAX_DOUBLE)" -->
int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aa5152256eac42249db46ce9da25bef6a">remove_OF_bins</a> (TH1 *hist, double OFvalue=MAX_DOUBLE)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets OF bins to 0 and returns number of changed bins. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a46de81f4abf3af53a01184241d9e0c39"></a><!-- doxytag: member="root_utils.h::remove_INF_bins" ref="a46de81f4abf3af53a01184241d9e0c39" args="(TH1 *hist)" -->
int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a46de81f4abf3af53a01184241d9e0c39">remove_INF_bins</a> (TH1 *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets INF bins to 0 and returns number of changed bins. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7f7545e19b09d715b30aaf8aa6acce37"></a><!-- doxytag: member="root_utils.h::make_bins_absolute_values" ref="a7f7545e19b09d715b30aaf8aa6acce37" args="(TH1F *hist)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a7f7545e19b09d715b30aaf8aa6acce37">make_bins_absolute_values</a> (TH1F *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the histogram bins equal to their absolute value. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7371178dcf38d6941a3ba1e03207e54c"></a><!-- doxytag: member="root_utils.h::make_bins_square_roots" ref="a7371178dcf38d6941a3ba1e03207e54c" args="(TH1F *hist)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a7371178dcf38d6941a3ba1e03207e54c">make_bins_square_roots</a> (TH1F *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the histogram bins equal to their square root. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#acad111204d7306d6a50dbe9bccd32cc3">add_symm_bin_err_from_diff</a> (TH1F *hErr, TH1F *hOrig, TH1F *hVarUp, TH1F *hVarDw, bool noNormUnc=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extends a histogram holding bin errors as contents.  <a href="#acad111204d7306d6a50dbe9bccd32cc3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8cacf8babb173e3ea6cee6b87ed7724e"></a><!-- doxytag: member="root_utils.h::set_bin_err_from_diff" ref="a8cacf8babb173e3ea6cee6b87ed7724e" args="(TGraphAsymmErrors *grOrig, TGraph *grVar0, TGraph *grVar1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a8cacf8babb173e3ea6cee6b87ed7724e">set_bin_err_from_diff</a> (TGraphAsymmErrors *grOrig, TGraph *grVar0, TGraph *grVar1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assigns uncertainties to graph based on two variation graphs. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a609d475f8fcb2c1e7dac07d4272d858e"></a><!-- doxytag: member="root_utils.h::set_bin_err_from_diff" ref="a609d475f8fcb2c1e7dac07d4272d858e" args="(TH1F *hOrig, TH1F *hVar0, TH1F *hVar1, bool norm=false)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a609d475f8fcb2c1e7dac07d4272d858e">set_bin_err_from_diff</a> (TH1F *hOrig, TH1F *hVar0, TH1F *hVar1, bool norm=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assigns uncertainties to histogram based on two variation histograms. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5e29d3b8dbed9104b10f6d0b37ed6c4d"></a><!-- doxytag: member="root_utils.h::get_hist_chi2_diff" ref="a5e29d3b8dbed9104b10f6d0b37ed6c4d" args="(TH1F *h1, TH1F *h2, bool norm=false, double xMin=0, double xMax=0)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a5e29d3b8dbed9104b10f6d0b37ed6c4d">get_hist_chi2_diff</a> (TH1F *h1, TH1F *h2, bool norm=false, double xMin=0, double xMax=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the chi2 from comparison of two histograms. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3306c6dc6eda1b3b7b61c4e595089f38"></a><!-- doxytag: member="root_utils.h::get_hist_chi2_diff" ref="a3306c6dc6eda1b3b7b61c4e595089f38" args="(TH1F *hist, TF1 *func, bool norm=false, double xMin=0, double xMax=0)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a3306c6dc6eda1b3b7b61c4e595089f38">get_hist_chi2_diff</a> (TH1F *hist, TF1 *func, bool norm=false, double xMin=0, double xMax=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the chi2 from comparison of a histogram and a function. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a87e88a5485393ebe2fcca18793a69351"></a><!-- doxytag: member="root_utils.h::smear_bins" ref="a87e88a5485393ebe2fcca18793a69351" args="(TH1F *hist, TH1F *hUnc, int seed)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a87e88a5485393ebe2fcca18793a69351">smear_bins</a> (TH1F *hist, TH1F *hUnc, int seed)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Smear the bins of a histogram according to specified uncertainties. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2c18706cf157b04e64c9ca97e2372ab3"></a><!-- doxytag: member="root_utils.h::smear_bins" ref="a2c18706cf157b04e64c9ca97e2372ab3" args="(TH1F *, int seed=0)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a2c18706cf157b04e64c9ca97e2372ab3">smear_bins</a> (TH1F *, int seed=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Smear the bins of a histogram according to square root uncertainties. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9517fecd63b8cf80caca73ce3eb67c79"></a><!-- doxytag: member="root_utils.h::print_matrix" ref="a9517fecd63b8cf80caca73ce3eb67c79" args="(const TMatrixD &amp;m, std::string format=&quot;&quot;, const std::string &amp;name=&quot;&quot;, int colsPerSheet=10)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a9517fecd63b8cf80caca73ce3eb67c79">print_matrix</a> (const TMatrixD &amp;m, std::string format=&quot;&quot;, const std::string &amp;name=&quot;&quot;, int colsPerSheet=10)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Display a matrix in stdout. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a487316e2526f90b1c086abab711f825b"></a><!-- doxytag: member="root_utils.h::remove_row_column" ref="a487316e2526f90b1c086abab711f825b" args="(TMatrixD *m, std::vector&lt; int &gt; rows, std::vector&lt; int &gt; cols, bool verbose=false)" -->
TMatrixD *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a487316e2526f90b1c086abab711f825b">remove_row_column</a> (TMatrixD *m, std::vector&lt; int &gt; rows, std::vector&lt; int &gt; cols, bool verbose=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove several rows and/or columns from a matrix. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad3f0e2ec8aeea3776c1d524150cd1940"></a><!-- doxytag: member="root_utils.h::remove_row_column" ref="ad3f0e2ec8aeea3776c1d524150cd1940" args="(TMatrixD *m, int row=&#45;1, int col=&#45;1, int verbose=1)" -->
TMatrixD *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ad3f0e2ec8aeea3776c1d524150cd1940">remove_row_column</a> (TMatrixD *m, int row=-1, int col=-1, int verbose=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove a single row and/or column from a matrix. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acca3f8e28670de819ba52c027eac6bab"></a><!-- doxytag: member="root_utils.h::convert_matrix_to_hist" ref="acca3f8e28670de819ba52c027eac6bab" args="(TMatrixD m)" -->
TH2D *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#acca3f8e28670de819ba52c027eac6bab">convert_matrix_to_hist</a> (TMatrixD m)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert a 2D matrix to a 2D histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5acec75dcfd64485bf2c1eec4db1a686"></a><!-- doxytag: member="root_utils.h::convert_hist_to_matrix" ref="a5acec75dcfd64485bf2c1eec4db1a686" args="(TH2D *h)" -->
TMatrixD&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a5acec75dcfd64485bf2c1eec4db1a686">convert_hist_to_matrix</a> (TH2D *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert a 2D histogram to a 2D matrix. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1d05a5a4865a00b66c9b222ac2cb6786"></a><!-- doxytag: member="root_utils.h::scale_bins" ref="a1d05a5a4865a00b66c9b222ac2cb6786" args="(TH1F *hist, double scale)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a1d05a5a4865a00b66c9b222ac2cb6786">scale_bins</a> (TH1F *hist, double scale)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Scale the bins of the histogram by a factor. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4cc857ead2f39fb73e0e5f267a2c9ecd"></a><!-- doxytag: member="root_utils.h::function_ratio" ref="a4cc857ead2f39fb73e0e5f267a2c9ecd" args="(TF1 *f0, TF1 *f1, double min, double max, int nPoints=10000)" -->
TH1F *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a4cc857ead2f39fb73e0e5f267a2c9ecd">function_ratio</a> (TF1 *f0, TF1 *f1, double min, double max, int nPoints=10000)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the ratio of two functions. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1e6aba39ed98f02cf989ed17d5cb5e9f"></a><!-- doxytag: member="root_utils.h::average_error_per_bin" ref="a1e6aba39ed98f02cf989ed17d5cb5e9f" args="(TH1F *h)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a1e6aba39ed98f02cf989ed17d5cb5e9f">average_error_per_bin</a> (TH1F *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the average absolute error of all histogram bins. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a496b1a11ace2c0b69da62bb62b9c7400"></a><!-- doxytag: member="root_utils.h::cumulative_bin_residual" ref="a496b1a11ace2c0b69da62bb62b9c7400" args="(TH1F *h, TH1F *g)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a496b1a11ace2c0b69da62bb62b9c7400">cumulative_bin_residual</a> (TH1F *h, TH1F *g)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the cumulative signed residual of the histogram and the function. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a67695348c81a856343f95305f89391d6"></a><!-- doxytag: member="root_utils.h::get_plot_ranges" ref="a67695348c81a856343f95305f89391d6" args="(TGraphErrors **gr, int nGraphs=1, int skipNGraphs=0, bool extraTopSpace=false)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a67695348c81a856343f95305f89391d6">get_plot_ranges</a> (TGraphErrors **gr, int nGraphs=1, int skipNGraphs=0, bool extraTopSpace=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get max and min of array of graphs. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aee844e9b0ce5d6419d7a4d6188d3e3e3"></a><!-- doxytag: member="root_utils.h::get_plot_ranges" ref="aee844e9b0ce5d6419d7a4d6188d3e3e3" args="(TGraphErrors **gr, const std::vector&lt; int &gt; &amp;onlyThose, bool extraTopSpace=false)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aee844e9b0ce5d6419d7a4d6188d3e3e3">get_plot_ranges</a> (TGraphErrors **gr, const std::vector&lt; int &gt; &amp;onlyThose, bool extraTopSpace=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get max and min of array of graphs. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a764da4d60ace626975e5946cbc799b26"></a><!-- doxytag: member="root_utils.h::get_maximum" ref="a764da4d60ace626975e5946cbc799b26" args="(TGraph *gr, bool extraTopSpace=false)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a764da4d60ace626975e5946cbc799b26">get_maximum</a> (TGraph *gr, bool extraTopSpace=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the maximum y value of a graph. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae97b5a86dc5b0e8d00543f5a07e862f7"></a><!-- doxytag: member="root_utils.h::get_minimum" ref="ae97b5a86dc5b0e8d00543f5a07e862f7" args="(TGraph *gr, bool extraBottomSpace=false)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ae97b5a86dc5b0e8d00543f5a07e862f7">get_minimum</a> (TGraph *gr, bool extraBottomSpace=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the minimum y value of a graph. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a044952d2a3fb6224c1673d7af8259033"></a><!-- doxytag: member="root_utils.h::shift_x_values" ref="a044952d2a3fb6224c1673d7af8259033" args="(TGraph *gr, double shift)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a044952d2a3fb6224c1673d7af8259033">shift_x_values</a> (TGraph *gr, double shift)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shifts the x values of a graph, useful for plotting overlaid graphs. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a441d312650ab64d6bd568196f7431945"></a><!-- doxytag: member="root_utils.h::shift_x_values" ref="a441d312650ab64d6bd568196f7431945" args="(TGraph *gr, double maxShift, int thisIdx, int nGraphs)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a441d312650ab64d6bd568196f7431945">shift_x_values</a> (TGraph *gr, double maxShift, int thisIdx, int nGraphs)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">As <a class="el" href="root__utils_8h.html#a044952d2a3fb6224c1673d7af8259033" title="Shifts the x values of a graph, useful for plotting overlaid graphs.">shift_x_values()</a> but generates a shift for iterative plotting. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a88fe756d30280f91607bedc347b640ca"></a><!-- doxytag: member="root_utils.h::print_TTree_to_txt" ref="a88fe756d30280f91607bedc347b640ca" args="(const std::string &amp;fileName, int maxEvts=0)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a88fe756d30280f91607bedc347b640ca">print_TTree_to_txt</a> (const std::string &amp;fileName, int maxEvts=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Print tree contents to a txt file (still hardcoded branch names). <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a053be978e4337a08543f70b3377e9b35"></a><!-- doxytag: member="root_utils.h::bin_positive_error" ref="a053be978e4337a08543f70b3377e9b35" args="(TH1F *hist, int bin)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a053be978e4337a08543f70b3377e9b35">bin_positive_error</a> (TH1F *hist, int bin)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns x range ((xup-xdw)/2) around bin with compatible bin content. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adef7853097730bbbf3d0386c41391da1"></a><!-- doxytag: member="root_utils.h::get_FWHM" ref="adef7853097730bbbf3d0386c41391da1" args="(TH1F *hist)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#adef7853097730bbbf3d0386c41391da1">get_FWHM</a> (TH1F *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the Full Width at Half Maximum (FWHM) of the histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8ab9de71f73a60a0652e91c0fda35f65"></a><!-- doxytag: member="root_utils.h::get_FWHM_unc" ref="a8ab9de71f73a60a0652e91c0fda35f65" args="(TH1F *hist)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a8ab9de71f73a60a0652e91c0fda35f65">get_FWHM_unc</a> (TH1F *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the uncertainty of the FWHM of the histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a08e79617eb88e1c421d6fee032e73626"></a><!-- doxytag: member="root_utils.h::print_bins" ref="a08e79617eb88e1c421d6fee032e73626" args="(TH1F *hist)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a08e79617eb88e1c421d6fee032e73626">print_bins</a> (TH1F *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Prints the bins of the histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a12edfb6cec8ac65c45d01ddaee78fbb4"></a><!-- doxytag: member="root_utils.h::divide_hists" ref="a12edfb6cec8ac65c45d01ddaee78fbb4" args="(TH2F *h, TH2F *g)" -->
TH2F *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a12edfb6cec8ac65c45d01ddaee78fbb4">divide_hists</a> (TH2F *h, TH2F *g)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the bin by bin ratio of two histograms. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a24a55d63491e537beccdacd7837463d8"></a><!-- doxytag: member="root_utils.h::set_close_bins_to_one" ref="a24a55d63491e537beccdacd7837463d8" args="(TH2F *hist)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a24a55d63491e537beccdacd7837463d8">set_close_bins_to_one</a> (TH2F *hist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the bins compatible with 1 to one, used for 2D ratio plots. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a74574fbfb5ea5f63cb99cb51d8f25203"></a><!-- doxytag: member="root_utils.h::set_max_of_hists" ref="a74574fbfb5ea5f63cb99cb51d8f25203" args="(TH1 *h=nullptr, TH1 *h1=nullptr)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a74574fbfb5ea5f63cb99cb51d8f25203">set_max_of_hists</a> (TH1 *h=nullptr, TH1 *h1=nullptr)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the maximum of h to the maximum of h and h1. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adaf96c01bf3502b535bd39173aa8053a"></a><!-- doxytag: member="root_utils.h::delete_obj_from_file" ref="adaf96c01bf3502b535bd39173aa8053a" args="(const std::string &amp;fileName, const std::string &amp;objectName)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#adaf96c01bf3502b535bd39173aa8053a">delete_obj_from_file</a> (const std::string &amp;fileName, const std::string &amp;objectName)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes an object from a root file. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abc6cc78d6c66b873e9f6c9db0d7c7c13"></a><!-- doxytag: member="root_utils.h::rotate_90_degrees" ref="abc6cc78d6c66b873e9f6c9db0d7c7c13" args="(TH2D *h)" -->
TH2D *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#abc6cc78d6c66b873e9f6c9db0d7c7c13">rotate_90_degrees</a> (TH2D *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Rotate a 2D histogram by 90 degrees. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a012aec2afb7ba96721e22c95a7b40188"></a><!-- doxytag: member="root_utils.h::randomize_hist" ref="a012aec2afb7ba96721e22c95a7b40188" args="(TH1F *h, int entries=&#45;1)" -->
TH1F *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a012aec2afb7ba96721e22c95a7b40188">randomize_hist</a> (TH1F *h, int entries=-1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a histogram randomized from h with specified number of entries. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab1e038b42b61e2e97b8c5ace222c54a3"></a><!-- doxytag: member="root_utils.h::replace_contents" ref="ab1e038b42b61e2e97b8c5ace222c54a3" args="(TH1 *hOrig, TH1 *hNew)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ab1e038b42b61e2e97b8c5ace222c54a3">replace_contents</a> (TH1 *hOrig, TH1 *hNew)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Replace the contents of one histogram with another. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7d7697dc052c3d29d9428a8493d0bb67"></a><!-- doxytag: member="root_utils.h::draw_white_bin" ref="a7d7697dc052c3d29d9428a8493d0bb67" args="(int iBinX, int iBinY, TH2D *h)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a7d7697dc052c3d29d9428a8493d0bb67">draw_white_bin</a> (int iBinX, int iBinY, TH2D *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Draw a white bin at specified bin position in histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac30263e2f5dfec51fbb387a4e38da2ea"></a><!-- doxytag: member="root_utils.h::FILL" ref="ac30263e2f5dfec51fbb387a4e38da2ea" args="(TH1F *hist, double x, double w)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ac30263e2f5dfec51fbb387a4e38da2ea">FILL</a> (TH1F *hist, double x, double w)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Special fill function where over- and underflow are filled into the first and last bin. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a97a44e646d262b02d686c1f457bd29aa"></a><!-- doxytag: member="root_utils.h::get_ratio" ref="a97a44e646d262b02d686c1f457bd29aa" args="(TH1F *hData, TH1F *hMC, int color=&#45;1, double min=0.9, double max=1.1, bool normalized=false, double corrSingleBins=0)" -->
TH1F *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a97a44e646d262b02d686c1f457bd29aa">get_ratio</a> (TH1F *hData, TH1F *hMC, int color=-1, double min=0.9, double max=1.1, bool normalized=false, double corrSingleBins=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the ratio of two histograms. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4026b8e9d39ae05296a179b3b7d6054e"></a><!-- doxytag: member="root_utils.h::poissonize" ref="a4026b8e9d39ae05296a179b3b7d6054e" args="(TH1 *h)" -->
TGraphAsymmErrors *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a4026b8e9d39ae05296a179b3b7d6054e">poissonize</a> (TH1 *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assigns Poisson errors to the histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a21efe8c8f350443c72b95bf193fa2984"></a><!-- doxytag: member="root_utils.h::GC_up" ref="a21efe8c8f350443c72b95bf193fa2984" args="(double hData)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a21efe8c8f350443c72b95bf193fa2984">GC_up</a> (double hData)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper function for <a class="el" href="root__utils_8h.html#a4026b8e9d39ae05296a179b3b7d6054e" title="Assigns Poisson errors to the histogram.">poissonize()</a>. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa8b3a855f5f24b50791295eccc7fa616"></a><!-- doxytag: member="root_utils.h::GC_down" ref="aa8b3a855f5f24b50791295eccc7fa616" args="(double hData)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aa8b3a855f5f24b50791295eccc7fa616">GC_down</a> (double hData)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper function for <a class="el" href="root__utils_8h.html#a4026b8e9d39ae05296a179b3b7d6054e" title="Assigns Poisson errors to the histogram.">poissonize()</a>. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adfba3529dcf2b65a2f546712786e94fd"></a><!-- doxytag: member="root_utils.h::asymm_bin_unc_graph" ref="adfba3529dcf2b65a2f546712786e94fd" args="(TH1F *hOrig, TH1F *hVarUp, TH1F *hVarDw)" -->
TGraphAsymmErrors *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#adfba3529dcf2b65a2f546712786e94fd">asymm_bin_unc_graph</a> (TH1F *hOrig, TH1F *hVarUp, TH1F *hVarDw)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assign asymmetric up and dw variation as uncertainty. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aa4dfacd85fe3761c4bd22ac46598110c">check_hist_compatibility</a> (TH1F *hData, TH1F *hMC, double textXPos=0.12, bool displayChi2=true, float xMin=0, float xMax=0, int nFuncPar=0, TH2D *hInvCov=nullptr)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Performs a number of tests to assess the compatibility of histograms.  <a href="#aa4dfacd85fe3761c4bd22ac46598110c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad8691632d7734900ddf39a9b49be3a84"></a><!-- doxytag: member="root_utils.h::check_hist_compatibility" ref="ad8691632d7734900ddf39a9b49be3a84" args="(TH1F *, TF1 *, double textXPos=0.12, bool displayChi2=true, float xMin=&#45;1, float xMax=&#45;1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ad8691632d7734900ddf39a9b49be3a84">check_hist_compatibility</a> (TH1F *, TF1 *, double textXPos=0.12, bool displayChi2=true, float xMin=-1, float xMax=-1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Like <a class="el" href="root__utils_8h.html#aa4dfacd85fe3761c4bd22ac46598110c" title="Performs a number of tests to assess the compatibility of histograms.">check_hist_compatibility()</a> but for a histogram and a function. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a18d50e6d34616a922b3c11a05cd79c99"></a><!-- doxytag: member="root_utils.h::project_to_y_axis" ref="a18d50e6d34616a922b3c11a05cd79c99" args="(TH1F *h, bool noEmptyBins=true, double maxY=0)" -->
TH1F *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a18d50e6d34616a922b3c11a05cd79c99">project_to_y_axis</a> (TH1F *h, bool noEmptyBins=true, double maxY=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the projection of a 1D histogram on its y-axis. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad7ee50b0268808b1f82d3033a8e34d28"></a><!-- doxytag: member="root_utils.h::get_average_bin_content" ref="ad7ee50b0268808b1f82d3033a8e34d28" args="(TH1F *h)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ad7ee50b0268808b1f82d3033a8e34d28">get_average_bin_content</a> (TH1F *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns mean, mean error and RMS of the average bin content from calling <a class="el" href="root__utils_8h.html#a18d50e6d34616a922b3c11a05cd79c99" title="Returns the projection of a 1D histogram on its y-axis.">project_to_y_axis()</a>. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8089ef778033c73dbd64560ec3ffa8fe"></a><!-- doxytag: member="root_utils.h::graph_integral" ref="a8089ef778033c73dbd64560ec3ffa8fe" args="(TGraph *g)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a8089ef778033c73dbd64560ec3ffa8fe">graph_integral</a> (TGraph *g)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the integral of a graph. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0c449da5ebbfb3f43b39f68c6bcd902a"></a><!-- doxytag: member="root_utils.h::get_graph_value" ref="a0c449da5ebbfb3f43b39f68c6bcd902a" args="(TGraph *g, int point)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a0c449da5ebbfb3f43b39f68c6bcd902a">get_graph_value</a> (TGraph *g, int point)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the y value of a graph of a point. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2ece6f4fd938f3f405850a536c876d2a"></a><!-- doxytag: member="root_utils.h::get_graph_point" ref="a2ece6f4fd938f3f405850a536c876d2a" args="(TGraphErrors *g, int point)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a2ece6f4fd938f3f405850a536c876d2a">get_graph_point</a> (TGraphErrors *g, int point)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns y value and its uncertainty of a graph point as array. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0bb0351ec8a6db461e11040d5c4fe0ee"></a><!-- doxytag: member="root_utils.h::get_graph_point" ref="a0bb0351ec8a6db461e11040d5c4fe0ee" args="(TGraphAsymmErrors *g, int point)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a0bb0351ec8a6db461e11040d5c4fe0ee">get_graph_point</a> (TGraphAsymmErrors *g, int point)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns y value and its uncertainty up and down of a graph point as array. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abf25311cae080738e37cb6b13dd5327b"></a><!-- doxytag: member="root_utils.h::draw_TH2F" ref="abf25311cae080738e37cb6b13dd5327b" args="(TH2F *h, const std::string &amp;drawoption=&quot;colz&quot;)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#abf25311cae080738e37cb6b13dd5327b">draw_TH2F</a> (TH2F *h, const std::string &amp;drawoption=&quot;colz&quot;)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper function to draw a nicely formatted 2D histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad67e62c730642972e92f40296f7821f5"></a><!-- doxytag: member="root_utils.h::shift_palette_axis" ref="ad67e62c730642972e92f40296f7821f5" args="(TH2F *h, double xShift=0)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ad67e62c730642972e92f40296f7821f5">shift_palette_axis</a> (TH2F *h, double xShift=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shifts the palette axis of a 2D histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5ed4b517dedbdfe1b2b7ec3c072462d3"></a><!-- doxytag: member="root_utils.h::resize_palette_axis" ref="a5ed4b517dedbdfe1b2b7ec3c072462d3" args="(TH2F *h, double x0, double x1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a5ed4b517dedbdfe1b2b7ec3c072462d3">resize_palette_axis</a> (TH2F *h, double x0, double x1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Resizes the palette axis of a 2D histogram. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a7f22a05c96ecc9dd25ed4d3c35af23e5">rotate_polygon</a> (TPolyLine *pline, double xCenter, double yCenter, double angle)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Rotates a polygon.  <a href="#a7f22a05c96ecc9dd25ed4d3c35af23e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aada94f063f33c90104e7de1a88c0fcbc"></a><!-- doxytag: member="root_utils.h::bend_polygon" ref="aada94f063f33c90104e7de1a88c0fcbc" args="(TPolyLine *pline, double strength, int granularity=6)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aada94f063f33c90104e7de1a88c0fcbc">bend_polygon</a> (TPolyLine *pline, double strength, int granularity=6)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Bend a polygon. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aeabf4fea0b696ad7cf781e02ca7b9349"></a><!-- doxytag: member="root_utils.h::enrich_polygon" ref="aeabf4fea0b696ad7cf781e02ca7b9349" args="(TPolyLine *pline, int granularity)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aeabf4fea0b696ad7cf781e02ca7b9349">enrich_polygon</a> (TPolyLine *pline, int granularity)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Fill lines between polygon points with additional points. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9e85e6c344c39150668c02638ee457d3"></a><!-- doxytag: member="root_utils.h::invert_polygon" ref="a9e85e6c344c39150668c02638ee457d3" args="(TPolyLine *pline, double xCenter, double yCenter)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a9e85e6c344c39150668c02638ee457d3">invert_polygon</a> (TPolyLine *pline, double xCenter, double yCenter)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Invert a polygon. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaa340edb1cce635446fb76803b86a214"></a><!-- doxytag: member="root_utils.h::stretch_polygon" ref="aaa340edb1cce635446fb76803b86a214" args="(TPolyLine *pline, double xStretch=1, double yStretch=1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#aaa340edb1cce635446fb76803b86a214">stretch_polygon</a> (TPolyLine *pline, double xStretch=1, double yStretch=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Stretch a polygon by factors in x and y direction. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a90ef4ca5a8f687b28b1cdd9e6804fe3c"></a><!-- doxytag: member="root_utils.h::shear_polygon" ref="a90ef4ca5a8f687b28b1cdd9e6804fe3c" args="(TPolyLine *pline, double xFactor=0, double yFactor=0)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a90ef4ca5a8f687b28b1cdd9e6804fe3c">shear_polygon</a> (TPolyLine *pline, double xFactor=0, double yFactor=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shear a polygon by factor in x and y direction. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a05f77171b727e9dca28971163eebc5ec"></a><!-- doxytag: member="root_utils.h::get_polygon_point" ref="a05f77171b727e9dca28971163eebc5ec" args="(TPolyLine *pline, double x, double y)" -->
int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a05f77171b727e9dca28971163eebc5ec">get_polygon_point</a> (TPolyLine *pline, double x, double y)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return index of polygon point matching x and y. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5d416ef2ca80aec3c88b06a7afbbaf07"></a><!-- doxytag: member="root_utils.h::crop_polygon" ref="a5d416ef2ca80aec3c88b06a7afbbaf07" args="(TPolyLine *pline, double xFrac=0, double yFrac=0)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a5d416ef2ca80aec3c88b06a7afbbaf07">crop_polygon</a> (TPolyLine *pline, double xFrac=0, double yFrac=0)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Crop a polygon at fractional size in x and y direction. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a66ae86db10308cecc8ad140b97237738"></a><!-- doxytag: member="root_utils.h::crop_polygon_above" ref="a66ae86db10308cecc8ad140b97237738" args="(TPolyLine *pline, double val, const std::string &amp;axis=&quot;X&quot;)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a66ae86db10308cecc8ad140b97237738">crop_polygon_above</a> (TPolyLine *pline, double val, const std::string &amp;axis=&quot;X&quot;)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remvove all points above a certain parameter value on axis. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a27a36023dafcc8714bf4ddcdcdaede1d"></a><!-- doxytag: member="root_utils.h::remove_duplicates" ref="a27a36023dafcc8714bf4ddcdcdaede1d" args="(TPolyLine *pline)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a27a36023dafcc8714bf4ddcdcdaede1d">remove_duplicates</a> (TPolyLine *pline)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove consecutively identical points from plygon. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad6d1b8f566920f7bbd8c1900a2470e85"></a><!-- doxytag: member="root_utils.h::remove_polygon_point" ref="ad6d1b8f566920f7bbd8c1900a2470e85" args="(TPolyLine *pline, int idx=&#45;1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ad6d1b8f566920f7bbd8c1900a2470e85">remove_polygon_point</a> (TPolyLine *pline, int idx=-1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove point at index from a polygon. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a76d47d91697f6315d5696336a2455703"></a><!-- doxytag: member="root_utils.h::insert_polygon_point" ref="a76d47d91697f6315d5696336a2455703" args="(TPolyLine *pline, double x, double y, int idx=&#45;1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a76d47d91697f6315d5696336a2455703">insert_polygon_point</a> (TPolyLine *pline, double x, double y, int idx=-1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Insert a point into a polygon after index. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a445f45bd448bd6f4c0a7f884879b194e"></a><!-- doxytag: member="root_utils.h::replace_polygon_point" ref="a445f45bd448bd6f4c0a7f884879b194e" args="(TPolyLine *pline, double x, double y, int idx=&#45;1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a445f45bd448bd6f4c0a7f884879b194e">replace_polygon_point</a> (TPolyLine *pline, double x, double y, int idx=-1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Replace a point at index in a polygon. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a668a281233fcc081a55cd25b83193839"></a><!-- doxytag: member="root_utils.h::get_poly_center_of_gravity" ref="a668a281233fcc081a55cd25b83193839" args="(TPolyLine *pline, bool dropLastPoint=false)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a668a281233fcc081a55cd25b83193839">get_poly_center_of_gravity</a> (TPolyLine *pline, bool dropLastPoint=false)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the center of gravity of a polygon around a given point. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6c4eb57d7fefe6e4cfa2d9a1e8de9bd9"></a><!-- doxytag: member="root_utils.h::find_first_x_above" ref="a6c4eb57d7fefe6e4cfa2d9a1e8de9bd9" args="(TSpline *spline, double yValue, double xMin, double xMax)" -->
double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a6c4eb57d7fefe6e4cfa2d9a1e8de9bd9">find_first_x_above</a> (TSpline *spline, double yValue, double xMin, double xMax)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns smallest x value with a y value between xMin and xMax. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2ff453befd14335e32c3f78981a2493a"></a><!-- doxytag: member="root_utils.h::check_hist_for_outliers" ref="a2ff453befd14335e32c3f78981a2493a" args="(TH1F *h, int verbose=1, double sigmaThreshold=5)" -->
bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a2ff453befd14335e32c3f78981a2493a">check_hist_for_outliers</a> (TH1F *h, int verbose=1, double sigmaThreshold=5)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Checks a histogram for outlier points, i.e. sudden jumps in value. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9c37b2a2669af587095023d3d3d1ef59"></a><!-- doxytag: member="root_utils.h::draw_TPave" ref="a9c37b2a2669af587095023d3d3d1ef59" args="(const std::vector&lt; std::string &gt; &amp;lines, double x1=0.22, double y1=0.83, double x2=0.3, double y2=0.92, double textSize=0.03, const std::string &amp;option=&quot;NDC&quot;, int color=1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a9c37b2a2669af587095023d3d3d1ef59">draw_TPave</a> (const std::vector&lt; std::string &gt; &amp;lines, double x1=0.22, double y1=0.83, double x2=0.3, double y2=0.92, double textSize=0.03, const std::string &amp;option=&quot;NDC&quot;, int color=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper function to draw a pave object with several lines of text. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4a26363ed65ffe20d7f932e33022c2ea"></a><!-- doxytag: member="root_utils.h::draw_TPave" ref="a4a26363ed65ffe20d7f932e33022c2ea" args="(const std::string &amp;line, double x1=0.22, double y1=0.83, double x2=0.3, double y2=0.92, double textSize=0.03, const std::string &amp;option=&quot;NDC&quot;, int color=1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a4a26363ed65ffe20d7f932e33022c2ea">draw_TPave</a> (const std::string &amp;line, double x1=0.22, double y1=0.83, double x2=0.3, double y2=0.92, double textSize=0.03, const std::string &amp;option=&quot;NDC&quot;, int color=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper function to draw a pave object with on line of text. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abf7169c8b0fc6824f632505671d35198"></a><!-- doxytag: member="root_utils.h::make_label" ref="abf7169c8b0fc6824f632505671d35198" args="(double x1, double y1, double x2, double y2, double size=0.03, double align=32)" -->
TPaveText *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#abf7169c8b0fc6824f632505671d35198">make_label</a> (double x1, double y1, double x2, double y2, double size=0.03, double align=32)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Helper function to make a label in a plot. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af6309f9f1864eae42d498749a6603d74"></a><!-- doxytag: member="root_utils.h::make_log_bins" ref="af6309f9f1864eae42d498749a6603d74" args="(TH1 *h, const std::string &amp;axis=&quot;x&quot;)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#af6309f9f1864eae42d498749a6603d74">make_log_bins</a> (TH1 *h, const std::string &amp;axis=&quot;x&quot;)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Transform bins on axis to be equidistant in log scale. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac4f36484804eee42c46a9a66a7f65da1"></a><!-- doxytag: member="root_utils.h::draw_bin_grid" ref="ac4f36484804eee42c46a9a66a7f65da1" args="(TH1 *h, const std::string &amp;axis=&quot;x&quot;, int lineStyle=3, int lineColor=1, int lineWidth=1)" -->
void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ac4f36484804eee42c46a9a66a7f65da1">draw_bin_grid</a> (TH1 *h, const std::string &amp;axis=&quot;x&quot;, int lineStyle=3, int lineColor=1, int lineWidth=1)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Draw dashed lines at bin boundaries. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab48eb2881da5c3108a101acd20f5586a"></a><!-- doxytag: member="root_utils.h::get_pad_boundary" ref="ab48eb2881da5c3108a101acd20f5586a" args="(TPad *pad)" -->
double *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#ab48eb2881da5c3108a101acd20f5586a">get_pad_boundary</a> (TPad *pad)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get absolute position of pad on canvas. Returns [xlow, ylow, xup, yup]. <br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4de828b70e4b5b95c6631ce098949172"></a><!-- doxytag: member="root_utils.h::unique_ID" ref="a4de828b70e4b5b95c6631ce098949172" args="(TH1 *h)" -->
std::string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="root__utils_8h.html#a4de828b70e4b5b95c6631ce098949172">unique_ID</a> (TH1 *h)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Prints some quantities for a histogram for equality testing. <br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>A collection of ROOT helper functions. </p>
<dl class="author"><dt><b>Author:</b></dt><dd>Andreas Alexander Maier </dd></dl>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="acad111204d7306d6a50dbe9bccd32cc3"></a><!-- doxytag: member="root_utils.h::add_symm_bin_err_from_diff" ref="acad111204d7306d6a50dbe9bccd32cc3" args="(TH1F *hErr, TH1F *hOrig, TH1F *hVarUp, TH1F *hVarDw, bool noNormUnc=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void add_symm_bin_err_from_diff </td>
          <td>(</td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>hErr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>hOrig</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>hVarUp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>hVarDw</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>noNormUnc</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Extends a histogram holding bin errors as contents. </p>
<p>Quadratically adds to error histogram hErr the symmetrized error taken from asymmetric up and dw variation histograms.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>noNormUnc</em>&nbsp;</td><td>drop normalization differences </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa4dfacd85fe3761c4bd22ac46598110c"></a><!-- doxytag: member="root_utils.h::check_hist_compatibility" ref="aa4dfacd85fe3761c4bd22ac46598110c" args="(TH1F *hData, TH1F *hMC, double textXPos=0.12, bool displayChi2=true, float xMin=0, float xMax=0, int nFuncPar=0, TH2D *hInvCov=nullptr)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void check_hist_compatibility </td>
          <td>(</td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>hData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>hMC</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>textXPos</em> = <code>0.12</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>displayChi2</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&nbsp;</td>
          <td class="paramname"> <em>xMin</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&nbsp;</td>
          <td class="paramname"> <em>xMax</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>nFuncPar</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TH2D *&nbsp;</td>
          <td class="paramname"> <em>hInvCov</em> = <code>nullptr</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Performs a number of tests to assess the compatibility of histograms. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>textXPos</em>&nbsp;</td><td>x position of the information to be printed at in a plot </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>displayChi2</em>&nbsp;</td><td>Optional parameter to print the results as pave in a plot </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>nFuncPar</em>&nbsp;</td><td>Optional parameter to subtract from the number of degrees of freedom </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>hInvCov</em>&nbsp;</td><td>Optional parameter to provide a covariance matrix for the two histograms </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a36974b18c7650c95c7812bfec5a6f6d0"></a><!-- doxytag: member="root_utils.h::get_min_hist_region" ref="a36974b18c7650c95c7812bfec5a6f6d0" args="(TH1F *h, double frac=1.0, const std::string &amp;quant=&quot;RMS&quot;, bool verbose=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double* get_min_hist_region </td>
          <td>(</td>
          <td class="paramtype">TH1F *&nbsp;</td>
          <td class="paramname"> <em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>frac</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&nbsp;</td>
          <td class="paramname"> <em>quant</em> = <code>&quot;RMS&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>verbose</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns quantity in smallest region containing frac of all events. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>quant</em>&nbsp;</td><td>Quantity to be determined in the region, e.g. 'RMS' or 'Mean' </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7f22a05c96ecc9dd25ed4d3c35af23e5"></a><!-- doxytag: member="root_utils.h::rotate_polygon" ref="a7f22a05c96ecc9dd25ed4d3c35af23e5" args="(TPolyLine *pline, double xCenter, double yCenter, double angle)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void rotate_polygon </td>
          <td>(</td>
          <td class="paramtype">TPolyLine *&nbsp;</td>
          <td class="paramname"> <em>pline</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>xCenter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>yCenter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>angle</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Rotates a polygon. </p>
<ul>
<li>angle &gt; 0: rotation</li>
<li>angle &lt; 0: invert x, then rotate </li>
</ul>

</div>
</div>
<a class="anchor" id="afb180631ffde31f2d493d4bad238fb5d"></a><!-- doxytag: member="root_utils.h::unc_of_ratio" ref="afb180631ffde31f2d493d4bad238fb5d" args="(double n, double N, double ne, double Ne, double corr, bool verbose=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double unc_of_ratio </td>
          <td>(</td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>N</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>ne</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>Ne</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>corr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>verbose</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the uncertainty of a ratio. </p>
<p><a href="https://en.wikipedia.org/wiki/Propagation_of_uncertainty#Example_formulas">https://en.wikipedia.org/wiki/Propagation_of_uncertainty#Example_formulas</a> </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1"/><address style="text-align: right;"><small>Generated on 29 May 2020 for HexPlot by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
